package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.HashMap;


/**
 * Constructs ILabels for IObjectGroups.
 *
 * @version          090104
 * @author           Magnus Rosell
 *
 */
public abstract class Describer implements HasProperties{

    protected Properties properties;

    public Describer(){
	this.properties = getDefaultProperties();	
    }


    public abstract HashMap<IObjectGroup, IVector<IVectorIndex>> describeGrouping(IObjectGrouping ioging, SparseISimilarity similarity);

    public abstract String getName();

}

