package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.*;


/**
 * Constructs ILabels for IObjectGroups.
 *
 * @version          090812
 * @author           Magnus Rosell
 *
 */
public class FrequentAndPredictiveEntropyDescriber extends Describer{

    public FrequentAndPredictiveEntropyDescriber(){
	this.properties = getDefaultProperties();
    }

    public FrequentAndPredictiveEntropyDescriber(mro.util.properties.Properties properties){
	this.properties = properties;
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Frequent And Predictive Entropy Describer Properties", CurrentClassGetter.getClassName());
		
	    /*
	try{

	    Property p = new Property("Number of objects in labels", 10, "The number of objects in each label");
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */

	return properties;
    }


    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }



    /*********************************/


    /*
    private IVector<IVectorIndex> describeGroup(IObjectGroup iog, 
					  SparseISimilarity similarity){

	return similarity.getGroupRepresentation(iog);
    }
    */

    public HashMap<IObjectGroup, IVector<IVectorIndex>> describeGrouping(IObjectGrouping ioging, SparseISimilarity similarity){

	if(!(similarity instanceof SparseDotSimilarity))
	    return null;

	FrequentAndPredictiveDescriber fapd = 
	    new FrequentAndPredictiveDescriber();
	HashMap<IObjectGroup, IVector<IVectorIndex>> groupDescriptionMap = 
	    fapd.describeGrouping(ioging, similarity);

	groupDescriptionMap = DescriptionManipulator.multiplyIndexesByEntropy(groupDescriptionMap);

	return groupDescriptionMap;
    }

    /*********************************/
   
    public String getName(){
	return "Frequent And Predictive Entropy Describer";
    }



}

