package infomat.vectorspace;

import java.util.*;

/**
 * A HierarchichalIObjectGrouping is a IObjectGrouping
 * with special properties. Algorithms shoud use the ordered group vector 
 * inhereted from IObjectGrouping to keep the currently focused level.
 *
 * <br><br>
 * Not yet fully implemented. There are issues with the adding of groups
 * as they are inhereted from IObjectGrouping. You have to know how to
 * use it. Not explained here.
 *
 * @version          080416
 * @author           Magnus Rosell
 */
public class HierarchicalIObjectGrouping extends IObjectGrouping
{
    private IObjectGroupNode root = null;

    private Vector<IObjectGroupNode> rootIObjectGroupNodes = null;
    private Vector<IObjectGroupNode> bottomIObjectGroupNodes = null;


    /*
    private Vector<IObjectGroupNode> allIObjectGroupNodes = 
	new Vector<IObjectGroupNode>();
    */

    public HierarchicalIObjectGrouping(String groupingName){
	super(groupingName);
    }

    public void setRootIObjectGroupNodes(Vector<IObjectGroupNode> nodeVec){
	rootIObjectGroupNodes = nodeVec;
    }

    public void setBottomIObjectGroupNodes(Vector<IObjectGroupNode> nodeVec){
	bottomIObjectGroupNodes = nodeVec;
    }

    public Vector<IObjectGroupNode> getRootIObjectGroupNodes(){
	return rootIObjectGroupNodes;
    }

    public Vector<IObjectGroupNode> getBottomIObjectGroupNodes(){
	return bottomIObjectGroupNodes;
    }

    public IObjectGrouping getRootIObjectGrouping(){
	if(rootIObjectGroupNodes==null)
	    return null;

	IObjectGrouping grouping = new IObjectGrouping("Root Grouping");
	Vector<IObjectGroup> groups = new Vector<IObjectGroup>();
	for(int i=0; i < rootIObjectGroupNodes.size(); i++)
	    groups.add(rootIObjectGroupNodes.elementAt(i).getIObjectGroup());
	grouping.addAllGroups(groups);
	return grouping;
    }

    public IObjectGrouping getBottomIObjectGrouping(){
	if(bottomIObjectGroupNodes==null)
	    return null;

	IObjectGrouping grouping = new IObjectGrouping("Bottom Grouping");
	Vector<IObjectGroup> groups = new Vector<IObjectGroup>();
	for(int i=0; i < bottomIObjectGroupNodes.size(); i++)
	    groups.add(bottomIObjectGroupNodes.elementAt(i).getIObjectGroup());
	grouping.addAllGroups(groups);
	return grouping;
    }

    
    public void setGroupingToRootGrouping(){
	removeAllGroups();
	for(int g=0; g<rootIObjectGroupNodes.size(); g++){
	    IObjectGroupNode node = rootIObjectGroupNodes.elementAt(g);
	    IObjectGroup group = node.getIObjectGroup();
	    add(group);
	}
    }

    public void setGroupingToBottomGrouping(){
	removeAllGroups();
	for(int g=0; g<bottomIObjectGroupNodes.size(); g++){
	    IObjectGroupNode node = bottomIObjectGroupNodes.elementAt(g);
	    IObjectGroup group = node.getIObjectGroup();
	    add(group);
	}
    }


    /*
    public Vector<IObjectGroup> getCurrentFlatGrouping(){
	return getGroups();
    }

    public IObjectGroupNode getRootNode(){
	return root;
    }

    public void setRootNode(IObjectGroupNode root){
	this.root=root;
    }
    */

    




    public void printHierarchy(){
	if(rootIObjectGroupNodes!=null &&
	   rootIObjectGroupNodes.size()>0){
	    for(int i=0; i<rootIObjectGroupNodes.size(); i++)
		printHierarchy(rootIObjectGroupNodes.elementAt(i), "", "*");
	}
    }

    public void printHierarchy(IObjectGroupNode node, 
			       String indent, String character){
	System.out.println(indent+character+" "+node.getIObjectGroup().getName()+" ("+node.getIObjectGroup().numberOfIObjects()+")");

	indent += "   ";
	if(character.compareTo("*")==0)
	    character = "x";
	else
	    character = "*";
	Vector<IObjectGroupNode> children = node.getChildren();
	if(children != null){
	    for(int i=0; i<children.size(); i++){
		node = children.elementAt(i);
		printHierarchy(node, indent, character);
	    }
	}
    }

    /*
    public void printHierarchy(){
	printHierarchy(root, "", "*");
    }

    public void printHierarchy(IObjectGroupNode node, 
			       String indent, String character){
	System.out.println(indent+character+" "+node.getIObjectGroup().getName()+" ("+node.getIObjectGroup().numberOfIObjects()+")");

	indent += "   ";
	if(character.compareTo("*")==0)
	    character = "x";
	else
	    character = "*";
	Vector<IObjectGroupNode> children = node.getChildren();
	if(children != null){
	    for(int i=0; i<children.size(); i++){
		node = children.elementAt(i);
		printHierarchy(node, indent, character);
	    }
	}
    }

    */

}

