package infomat.vectorspace;

//import infomat.picture.*;
import infomat.io.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.doublehashmap.DoubleHashMap;

import java.io.*;
import java.util.*;
import java.awt.Dimension;

import javax.swing.JLabel;


/**
 *
 * @version          080618
 * @author           Magnus Rosell
 */
public class IMatrixProjector{


    /*
    public IMatrix projectAlongColumns(IMatrix m, 
				       SparseISimilarity columnSimilarity, 
				       IObjectGrouping columnGrouping){
	
	String columnLabel = columnGrouping.getName();
	String rowLabel = m.getRowIObjectSet().getString();
	IMatrix ret = new IMatrix(columnLabel, rowLabel);

	Vector<IObjectGroup> ciogs = columnGrouping.getGroups();
	HashMap<IObjectGroup, HashMap<IObject, Float>> centroids = 
	    new HashMap<IObjectGroup, HashMap<IObject, Float>>();
	for(int i=0; i<ciogs.size(); i++){
	    IObjectGroup ciog = ciogs.elementAt(i);
	    ret.addColumnIObject(ciog);
	    HashMap<IObject, Float> repr = 
		columnSimilarity.getGroupRepresentation(ciog);
	    centroids.put(ciog, repr);
	}
	
	HashMap<IObject, HashMap<IObjectGroup, Float>> columnObjectGroupSim =
	    new HashMap<IObject, HashMap<IObjectGroup, Float>>();
	Vector<IObject> cios = columnGrouping.getOrdered();
	for(int i=0; i<cios.size(); i++){
	    IObject cio = cios.elementAt(i);
	    HashMap<IObject, Float> repr = 
		columnSimilarity.getRepresentation(cio);
	    HashMap<IObjectGroup, Float> groupSim = 
		new HashMap<IObjectGroup, Float>();
	    for(int j=0; j<ciogs.size(); j++){
		IObjectGroup ciog = ciogs.elementAt(j);
		groupSim.put(ciog, columnSimilarity.sim(repr, centroids.get(ciog)));
	    }
	    columnObjectGroupSim.put(cio, groupSim);
	}
	
	IObjectGroup set = m.getRowIObjectSet();
	Vector<IObject> rios = set.getOrdered();
	for(int i=0; i<rios.size(); i++){
	    IObject rio = rios.elementAt(i);
	    ret.addRowIObject(rio);
	    
	    HashSet columnCells = m.getColumnIMatrixCellsForRowObject(rio);
	    Iterator it = columnCells.iterator();
	    while(it.hasNext()){
		IMatrixCell origCell = (IMatrixCell) it.next();
		IObject cio = origCell.getColumnIObject();
		float origVal = origCell.getWeight();

		HashMap<IObjectGroup, Float> groupSim = 
		    columnObjectGroupSim.get(cio);
		Iterator<Map.Entry<IObjectGroup, Float>> groupIt = 
		    groupSim.entrySet().iterator();
		while(groupIt.hasNext()){
		    Map.Entry<IObjectGroup, Float> entry = groupIt.next();
		    IObjectGroup ciog = entry.getKey();
		    float projVal = entry.getValue();

		    IMatrixCell mc = ret.getCell(rio, ciog);
		    if(mc==null){
			mc = new IMatrixCell(origCell);
			mc.setColumnIObject(ciog);
			mc.setWeight(origVal*projVal); 
			ret.addCell(mc);
		    }else{
			mc.addToLocalCount(origCell.getLocalCount() * projVal);
			mc.setWeight(mc.getWeight() + origVal*projVal);
		    }
		}
	    }
	}
	
	return ret;
    }
    */



    public IMatrix projectAlongColumns(IMatrix m, 
				       SparseISimilarity columnSimilarity, 
				       IObjectGrouping columnGrouping){
	
	Vector<IObjectGroup> ciogs = columnGrouping.getGroups();
	HashMap<IObjectGroup, IVector<IVectorIndex>> centroids = 
	    new HashMap<IObjectGroup, IVector<IVectorIndex>>();
	for(int i=0; i<ciogs.size(); i++){
	    IObjectGroup ciog = ciogs.elementAt(i);
	    IVector<IVectorIndex> repr = 
		columnSimilarity.getGroupRepresentation(ciog);
	    centroids.put(ciog, repr);
	}
	
	HashMap<IObject, HashMap<IObjectGroup, Float>> columnObjectGroupSim =
	    new HashMap<IObject, HashMap<IObjectGroup, Float>>();
	Vector<IObject> cios = columnGrouping.getOrdered();
	for(int i=0; i<cios.size(); i++){
	    IObject cio = cios.elementAt(i);
	    IVector<IVectorIndex> repr = 
		columnSimilarity.getRepresentation(cio);
	    HashMap<IObjectGroup, Float> groupSim = 
		new HashMap<IObjectGroup, Float>();
	    for(int j=0; j<ciogs.size(); j++){
		IObjectGroup ciog = ciogs.elementAt(j);
		groupSim.put(ciog, columnSimilarity.sim(repr, centroids.get(ciog)));
	    }
	    columnObjectGroupSim.put(cio, groupSim);
	}

	return projectAlongColumns(m, columnObjectGroupSim, columnGrouping);
    }


    /**
     * A very bad idea.
     */
    public IMatrix projectOnBestColumnGroups(IMatrix m, 
					     SparseISimilarity columnSimilarity, 
					     IObjectGrouping columnGrouping){
	
	Vector<IObjectGroup> ciogs = columnGrouping.getGroups();
	HashMap<IObject, HashMap<IObjectGroup, Float>> columnObjectGroupSim =
	    new HashMap<IObject, HashMap<IObjectGroup, Float>>();
	for(int i=0; i<ciogs.size(); i++){
	    IObjectGroup ciog = ciogs.elementAt(i);
	    IVector<IVectorIndex> centroid = 
		columnSimilarity.getGroupRepresentation(ciog);

	    HashMap<IObjectGroup, Float> groupSim = 
		new HashMap<IObjectGroup, Float>();
	    Vector<IObject> cios = ciog.getOrdered();
	    for(int j=0; j<cios.size(); j++){
		IObject cio = cios.elementAt(j);
		IVector<IVectorIndex> repr = 
		    columnSimilarity.getRepresentation(cio);
		groupSim.put(ciog, columnSimilarity.sim(repr, centroid));
		columnObjectGroupSim.put(cio, groupSim);
	    }
	}
	return projectAlongColumns(m, columnObjectGroupSim, columnGrouping);
    }





    public IMatrix projectAlongColumns(IMatrix m, 
				       HashMap<IObject, HashMap<IObjectGroup, Float>> columnObjectGroupSim, 
				       IObjectGrouping columnGrouping){
	

	String columnLabel = columnGrouping.getName();
	String rowLabel = m.getRowIObjectSet().getString();
	IMatrix ret = new IMatrix(columnLabel, rowLabel);

	Vector<IObjectGroup> ciogs = columnGrouping.getGroups();
	for(int i=0; i<ciogs.size(); i++){
	    IObjectGroup ciog = ciogs.elementAt(i);
	    ret.addColumnIObject(ciog);
	}
	
	IObjectGroup set = m.getRowIObjectSet();
	Vector<IObject> rios = set.getOrdered();
	for(int i=0; i<rios.size(); i++){
	    IObject rio = rios.elementAt(i);
	    ret.addRowIObject(rio);
	    
	    HashSet columnCells = m.getColumnIMatrixCellsForRowObject(rio);
	    Iterator it = columnCells.iterator();
	    while(it.hasNext()){
		IMatrixCell origCell = (IMatrixCell) it.next();
		IObject cio = origCell.getColumnIObject();
		float origVal = origCell.getWeight();

		HashMap<IObjectGroup, Float> groupSim = 
		    columnObjectGroupSim.get(cio);
		Iterator<Map.Entry<IObjectGroup, Float>> groupIt = 
		    groupSim.entrySet().iterator();
		while(groupIt.hasNext()){
		    Map.Entry<IObjectGroup, Float> entry = groupIt.next();
		    IObjectGroup ciog = entry.getKey();
		    float projVal = entry.getValue();

		    IMatrixCell mc = ret.getCell(rio, ciog);
		    if(mc==null){
			mc = new IMatrixCell(origCell);
			mc.setColumnIObject(ciog);
			mc.setWeight(origVal*projVal); 
			ret.addCell(mc);
		    }else{
			mc.addToLocalCount(origCell.getLocalCount() * projVal);
			mc.setWeight(mc.getWeight() + origVal*projVal);
		    }
		}
	    }
	}
	
	return ret;
    }




}
