package infomat.vectorspace;

import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import java.util.*;

/**
 * A class for sorting of IObject:s.
 *
 * @version          080218
 * @author           Magnus Rosell
 */
public class Sorter{

    /*
    public static IObjectGrouping 
	makeWeightGroupingRelativeGroupingOfOtherSet(IObjectGroup iogroup, IObjectGrouping grouping, ISimilarity similarity){
		
	// Tillverka ny gruppering
	IObjectGrouping coging = 
	    new IObjectGrouping("Weight Grouping relative "+grouping.getName());

	if(similarity instanceof SparseISimilarity){
	    SparseISimilarity sparseSim = (SparseISimilarity) similarity;

	    // Tillverka centroider och nya grupper
	    HashMap<Integer, IObjectGroup> groupingMap = 
		new HashMap<Integer, IObjectGroup>();
	    Vector centroids = new Vector();
	    Vector<IObjectGroup> groups = grouping.getGroups();
	    for(int i=0; i<groups.size(); i++){
		IObjectGroup cog = groups.elementAt(i);
		IVector<IObject> vec = sparseSim.getGroupRepresentation(cog);
		HashMap<IObject, Float> centroid = vec.getMap();
		centroids.add(centroid);

		IObjectGroup newCOG = 
		    new IObjectGroup("Weight Group relative "+cog.getString());
		coging.add(newCOG);
		groupingMap.put(i, newCOG);
	    }

	    // G igenom alla objekt och lgg i rtt nya grupp
	    Vector<IObject> vec = iogroup.getOrdered();
	    for(int i=0; i<vec.size(); i++){
		IObject co = vec.elementAt(i);
		int gr=0;
		float grWeight=0.0f;
		for(int g=0; g<centroids.size(); g++){
		    HashMap<IObject, Float> centroid = (HashMap<IObject, Float>)
			centroids.elementAt(g);
		    Float w = centroid.get(co);
		    if(w!=null && w>grWeight){
			gr=g;
			grWeight=w;
		    }
		}
		IObjectGroup cog = groupingMap.get(gr);
		cog.add(co, grWeight);
		coging.add(co, i*10+gr);
	    }
	}else if(similarity instanceof DenseISimilarity){
	    // Not implemented yet.
	    // Don't know if it is interesting.
	}

	return coging;
    }
    */


	
    /*
      public static float compareObjectToCentroid(HashMap<IObject, Float> representation,
      HashMap<IObject, Float> centroid){
      float sim =0f;
      Set<Map.Entry<IObject, Float>> set = representation.entrySet();
      Iterator<Map.Entry<IObject, Float>> it = set.iterator();
      while(it.hasNext()){
      Map.Entry<IObject, Float> entry = it.next();
      Float f = centroid.get(entry.getKey());
      if(f!=null){
      sim+= f * entry.getValue();
      }
      }
      return sim;
      }
    */

	
    public static void sortInSimOrderWithinClusters(ISimilarity isimilarity, 
						    Vector<IObjectGroup> groups){
	if(isimilarity instanceof SparseISimilarity){
	    SparseISimilarity similarity = (SparseISimilarity) isimilarity;

	    for(int g=0; g<groups.size(); g++){
		IObjectGroup group = groups.elementAt(g);
		IVector<IVectorIndex> centroid = 
		    similarity.getGroupRepresentation(group);
		Vector<IObject> iobjects = group.getOrdered();
		group.removeAll();
		for(int i=0; i<iobjects.size(); i++){
		    IObject io = iobjects.elementAt(i);
		    IVector<IVectorIndex> representation = 
			similarity.getRepresentation(io);
		    float sim = similarity.sim(representation, centroid);
		    group.add(io, sim);
		}
		group.sortInOrderValueOrder();
	    }
	}else if(isimilarity instanceof DenseISimilarity){
	    DenseISimilarity similarity = (DenseISimilarity) isimilarity;

	    for(int g=0; g<groups.size(); g++){
		IObjectGroup group = groups.elementAt(g);

		float[] centroid = 
		    similarity.getGroupRepresentation(group);

		Vector<IObject> iobjects = group.getOrdered();
		group.removeAll();
		for(int i=0; i<iobjects.size(); i++){
		    IObject io = iobjects.elementAt(i);
		    float[] representation = 
			similarity.getRepresentation(io);
		    float sim = similarity.sim(representation, centroid);
		    group.add(io, sim);
		}
		group.sortInOrderValueOrder();
	    }
	}
    }


    public static void sortInRandomOrderWithinClusters(Vector<IObjectGroup> groups){
	for(int g=0; g<groups.size(); g++){
	    IObjectGroup group = groups.elementAt(g);
	    group.randomOrder();
	}
    }

    public static void sortInLexicalOrderWithinClusters(Vector<IObjectGroup> groups){
	for(int g=0; g<groups.size(); g++){
	    IObjectGroup group = groups.elementAt(g);

	    Vector<IObject> iobjects = group.getOrdered();
	    group.removeAll();
	    IObjectLexicalComparator iolc = new IObjectLexicalComparator();
	    
	    Collections.sort(iobjects, iolc);
	    for(int i=0; i<iobjects.size(); i++){
		IObject io = iobjects.elementAt(i);
		group.add(io, i);
	    }
	    group.sortInOrderValueOrder();
	}
    }


}


/**
 * A private class that is used to order the IObjects in lexical order.
 */
class IObjectLexicalComparator implements Comparator{

    /**
     * Compares two IObject:s lexically and returns 1, 0 or -1 
     *
     * @param  o1 a IObject
     * @param  o2 a IObject
     * @return int 
     */
    public int compare(Object o1, Object o2) {
	String s1 = ((IObject) o1).getString();
	String s2 = ((IObject) o2).getString();
	return s1.compareTo(s2);
    }    

}


	
