package infomat.vectorspace.similarity;

import infomat.vectorspace.*;
import infomat.vectorspace.ivector.*;

import mro.util.properties.*;

import java.util.HashMap;

/**
 * Similarity measure for sparse IMatrix.
 *
 *
 * @version          080627
 * @author           Magnus Rosell
 */
public abstract class SparseISimilarity extends ISimilarity{

    public SparseISimilarity(){
	super();
    }

    public SparseISimilarity(SparseISimilarity sim){
	try{
	    this.properties = new Properties(sim.getProperties());	
	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
    }

    public abstract <U extends IVectorIndex, V extends IVectorIndex> float sim(IVector<U> vec1, IVector<V> vec2);

    public abstract IVector<IVectorIndex> getRepresentation(IObject io);

    public abstract IVector<IVectorIndex> getGroupRepresentation(IObjectGroup iog);

}
