package infomat.view.group;

import infomat.view.*;
import infomat.view.picture.*;
import infomat.view.util.*;
import infomat.view.vector.*;
import infomat.vectorspace.*;
import infomat.vectorspace.ivector.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * 
 *
 * @version          080804
 * @author           Magnus Rosell
 */
public class GroupFrameManager{

    private HashMap<IObjectGroup, GroupFrame> groupFrameMap;

    public GroupFrameManager(){
	 groupFrameMap = new HashMap<IObjectGroup, GroupFrame>();
    }

    public GroupFrame add(IObjectGroup group, IObjectGrouping grouping, 
			  boolean row, InfomatView view){
	GroupFrame gf = groupFrameMap.get(group);
	if(gf==null){
	    gf = new GroupFrame(group, grouping, row, 
				view.getInfomatModel(), view);
	    gf.setVisible(true);
	    groupFrameMap.put(group, gf);
	}
	gf.toFront();

	if(group.numberOfIObjects()<1 || !grouping.contains(group)){
	    dispose(group);
	    return null;
	}
	return gf;
    }

    public void dispose(IObjectGroup group){
	GroupFrame gf = groupFrameMap.remove(group);
	if(gf!=null)
	    gf.dispose();
    }

    public void dispose(GroupFrame groupFrame){
	dispose(groupFrame.getGroup());
    }

    public void disposeAll(){
	Iterator<IObjectGroup> it = (new HashSet<IObjectGroup>(groupFrameMap.keySet())).iterator();
	while(it.hasNext()){
	    dispose(it.next());
	}
    }

    public void invert(){
	Iterator<GroupFrame> it = (new HashSet<GroupFrame>(groupFrameMap.values())).iterator();
	while(it.hasNext()){
	    it.next().invert();
	}
    }

}
