package infomat.view.menu;

import infomat.view.*;

import java.awt.event.*;

/**
 * Controller of the toolbar.
 */

public class ToolbarController implements ActionListener {

    //protected final static String SAVE = "Save";
    //protected final static String OVERVIEW = "Overview";
    protected final static String GRIDCOLUMN = "Column Grid";
    protected final static String GRIDROW = "Row Grid";

    protected final static String PIXELSELECTION= "Pixel Selection";
    protected final static String HAND = "Drag";
    protected final static String ZOOMSELECTION = "Zoom Selection";
    protected final static String ZOOMIN = "Zoom in";
    protected final static String REMOVE_COLUMNS = "Remove Columns";
    protected final static String REMOVE_ROWS = "Remove Rows";

    private ToolbarView vy;

    private Boolean inAction;

    private InfomatView infomatView;

    public ToolbarController(InfomatView infomatView) {
	this.infomatView = infomatView;
	vy = null;
	inAction = false;
    }

    protected void setToolbarView(ToolbarView vy) {
	this.vy = vy;
    }

    /**
     * Perform the right action for the right command
     * 
     * @param e
     *            The action performed
     */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	System.out.println("Toolbar event " + cmd);
	if (vy != null) {
	    if (!inAction
		&& (cmd.equals(PIXELSELECTION) 
		    || cmd.equals(HAND) 
		    || cmd.equals(ZOOMSELECTION)
		    //		    || cmd.equals(ZOOMIN) 
		    || cmd.equals(REMOVE_COLUMNS) 
		    || cmd.equals(REMOVE_ROWS))) {
		String pressed = vy.press(cmd);
		inAction = true;
		if (pressed == null)
		    infomatView
			.setMouseState(InfomatView.MOUSE_CHANGE_STATE_NONE);
		else if (pressed.equals(PIXELSELECTION))
		    infomatView
			.setMouseState(InfomatView.MOUSE_SELECT_PIXEL);
		else if (pressed.equals(HAND))
		    infomatView
			.setMouseState(InfomatView.MOUSE_CHANGE_STATE_DRAG);
		else if (pressed.equals(ZOOMSELECTION))
		    infomatView
			.setMouseState(InfomatView.MOUSE_CHANGE_STATE_ZOOMAREA);
		/*
		else if (pressed.equals(ZOOMIN))
		    infomatView
			.setMouseState(InfomatView.MOUSE_CHANGE_STATE_ZOOM);
		*/
		else if (pressed.equals(REMOVE_COLUMNS))
		    infomatView
			.setMouseState(InfomatView.MOUSE_REMOVE_COLUMNS);
		else if (pressed.equals(REMOVE_ROWS))
		    infomatView
			.setMouseState(InfomatView.MOUSE_REMOVE_ROWS);
	    } 
	    /*
	      else if (cmd.equals(OVERVIEW))
	      infomatView.toggleOverview();
	    */
	    else if (cmd.equals(GRIDCOLUMN))
		infomatView.toggleColumnGrid(true);
	    else if (cmd.equals(GRIDROW))
		infomatView.toggleRowGrid(true);
			
			
	    inAction = false;
	}
    }

    /**
     * Simulate a button press (from the menu)
     * 
     * @param button
     *            The name of the button
     */
    public void menuClick(String button) {
	vy.menuPress(button);
    }
}
