package infomat.view.selector;

import infomat.algorithms.grouping.*;
import infomat.io.*;
import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.view.*;
import infomat.view.util.*;
import infomat.view.grouping.settings.*;
import mro.util.properties.*;
import mro.util.properties.Properties;
import mro.util.properties.dialog.*;

import java.awt.*;
import java.awt.Dialog.*;//ModalityType;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;

import javax.swing.*;


	
/**
 *
 * @version          090316
 * @author           Magnus Rosell
 */
public class SimpleSelectionPanel extends JPanel implements ActionListener{

    private boolean selected = true;
    private JCheckBox all = new JCheckBox("All", true);
    private JCheckBox overview = new JCheckBox("Overview");
    private JCheckBox mainview = new JCheckBox("Main View");

    public SimpleSelectionPanel(String text){
	setLayout(new GridLayout(1,4));
	add(new JLabel(text));
	add(all);
	add(overview);
	add(mainview);


	all.addActionListener(this);
	overview.addActionListener(this);
	mainview.addActionListener(this);

    }

    public void setUnselected(){
	selected=false;
	deSelectAll();
	repaint();
    }

    public boolean isSelected(){
	return selected;
    }

    private void deSelectAll(){
	all.setSelected(false);
	mainview.setSelected(false);
	overview.setSelected(false);
    }

    public boolean all(){
	return all.isSelected();
    }

    public boolean overview(){
	return overview.isSelected();
    }

    public boolean mainview(){
	return mainview.isSelected();
    }

    public void actionPerformed(ActionEvent e) {
	if(e.getSource() instanceof JCheckBox){
	    JCheckBox source = (JCheckBox) e.getSource();

	    if(!selected)
		selected = true;

	    if(source == all){
		deSelectAll();
		all.setSelected(true);
		
		repaint();
	    }else if(source == overview){
		deSelectAll();
		overview.setSelected(true);
		repaint();
	    }else if(source == mainview){
		deSelectAll();
		mainview.setSelected(true);
		repaint();
	    }
	}
    }

}
