package mro.util.experimentation;

import mro.util.*;
import mro.util.doublehashmap.*;

import java.io.*;
import java.util.*; 

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;
import org.xml.sax.SAXException;


/**
 * Path Table. A class for handling a xml-table of paths.
 *
 * @version          080505
 * @author           Magnus Rosell
 */

public class PathEntry{
    
    private Vector<String> paths = null;
    private String measureAbbreviation;
    private String roundString = null;


    public void putPath(String path){
	if(paths==null)
	    paths = new Vector<String>();
	paths.add(path);
    }

    public void setPaths(Vector<String> paths){
	this.paths=paths;
    }
    
    public void setMeasureAbbreviation(String measureAbbreviation){
	this.measureAbbreviation=measureAbbreviation;
    }
    
    public void setRoundString(String roundString){
	this.roundString=roundString;
    }
    
    public Vector<String> getPaths(){
	return paths;
    }
    
    public String getMeasureAbbreviation(){
	return measureAbbreviation;
    }

    public String getRoundString(){
	return roundString;
    }
    
    public void printXML(PrintWriter pw) throws IOException{
	pw.print("<m>");
	pw.print(measureAbbreviation);
	pw.print("</m>");
	pw.print("<rd>");
	pw.print(roundString);
	pw.print("</rd>");
	for(int i=0; i<paths.size(); i++){
	    pw.print("<p>");
	    pw.print(paths.elementAt(i));
	    pw.print("</p>");
	}
    }

}

