package mro.util.properties;

import mro.util.*; 

import java.util.*; 

/**
 * The average of a property of some kind with description. 
 * Only works for Number.
 *
 * @version          050209
 * @author           Magnus Rosell
 */

public class PropertyAverage extends Property{

    public Object std;

    public PropertyAverage(){};

    public PropertyAverage(Vector properties){
	super("", "", "");

	Property p = (Property) properties.elementAt(0);
	this.name = p.name;
	this.value = p.value;
	this.propertyDescription = p.propertyDescription;

	if(p.valueDescriptions!=null){
	    for(int i=0; i<p.valueDescriptions.size(); i++){
		PropertyValueDescription cpvd = (PropertyValueDescription)
		    p.valueDescriptions.elementAt(i);
		addValueDescription(cpvd);
	    }
	}
	
	float mean=0f;
	float dev=0f;
	if(p.value instanceof Number){

	    for(int i=0; i<properties.size(); i++){
		p = (Property) properties.elementAt(i);
		float value = ((Number) p.value).floatValue();
		mean+=value;
	    }
	    mean = ((float) mean)/properties.size();
	    
	    for(int i=0; i<properties.size(); i++){
		p = (Property) properties.elementAt(i);
		float value = ((Number) p.value).floatValue();
		dev+=Math.pow((value-mean),2);
	    }
	    dev=(float) Math.sqrt(dev/properties.size());
	}
	value = new Float(mean);
	std = new Float(dev);
    }

    public Object getStd(){
	return std;
    }

    /*
    private String valueString(){
	String s="";
	if(roundValue && value instanceof Float && std instanceof Float){
	    
	    s=Round.roundDecimalsToTrimmedString(((Float) value).floatValue(),
						 roundFloatToNumOfDecimals);
	    s+=", "+Round.roundDecimalsToTrimmedString(((Float) std).floatValue(),
						       roundFloatToNumOfDecimals);
	}else
	    s += ""+value+", "+std;
	return s;
    }
    */

}


